//---------------------------------------------------------------------------
#pragma once

#include "atlctrls.h" // for WTL::CProgressBarCtrl*
#include <vector>
#include <map>
//---------------------------------------------------------------------------
enum EFuncGroup {	FG_ARIPH, FG_LOG, FG_TEXT, FG_DATETIME, FG_FIN, FG_STAT, 
					FG_INF, FG_BD, FG_SSYLKA, FG_INJENER, FG_MISCEL, FG_ARRAY};
//---------------------------------------------------------------------------
class ExcelFile
{
protected:
public:
    ExcelFile();
    virtual ~ExcelFile();

    bool SaveCommon( const std::string& strFilePath,
					 bool fIsWithFormulas,
					 WTL::CProgressBarCtrl*	progress);

    std::string GetFormula_Ariph( int nFormulaOrdinal);
    std::string GetFormulaText_Ariph( int nFormulaOrdinal);

    std::string GetFormula_Log( int nFormulaOrdinal);
    std::string GetFormulaText_Log( int nFormulaOrdinal);

    std::string GetFormula_Text( int nFormulaOrdinal);
    std::string GetFormulaText_Text( int nFormulaOrdinal);

    std::string GetFormula_DateTime( int nFormulaOrdinal);
    std::string GetFormulaText_DateTime( int nFormulaOrdinal);

    std::string GetFormula_Fin( int nFormulaOrdinal);
    std::string GetFormulaText_Fin( int nFormulaOrdinal);

    std::string GetFormula_Stat( int nFormulaOrdinal);
    std::string GetFormulaText_Stat( int nFormulaOrdinal);

    std::string GetFormula_Inf( int nFormulaOrdinal);
    std::string GetFormulaText_Inf( int nFormulaOrdinal);

    std::string GetFormula_BD( int nFormulaOrdinal);
    std::string GetFormulaText_BD( int nFormulaOrdinal);

    std::string GetFormula_Ssylka( int nFormulaOrdinal);
    std::string GetFormulaText_Ssylka( int nFormulaOrdinal);

    std::string GetFormula_Injener( int nFormulaOrdinal);
    std::string GetFormulaText_Injener( int nFormulaOrdinal);

    std::string GetFormula_Miscel( int nFormulaOrdinal);
    std::string GetFormulaText_Miscel( int nFormulaOrdinal);

    std::string GetFormula_Array( int nFormulaOrdinal);
    std::string GetFormulaText_Array( int nFormulaOrdinal);

    std::string GetFormula_Formulas( int nFormulaOrdinal);
    std::string GetFormulaText_Formulas( int nFormulaOrdinal);

protected:
	void TrimRight( std::string& str);
	std::string& Replace( std::string& str, char oldc, char newc);
};
//---------------------------------------------------------------------------
